/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.sis.test;

import java.util.List;
import java.util.Map;
import java.util.Random;

import de.tudarmstadt.maki.simonstrator.api.Host;
import de.tudarmstadt.maki.simonstrator.api.common.graph.INodeID;
import de.tudarmstadt.maki.simonstrator.api.component.ComponentNotAvailableException;
import de.tudarmstadt.maki.simonstrator.api.component.HostComponent;
import de.tudarmstadt.maki.simonstrator.api.component.network.NetworkComponent;
import de.tudarmstadt.maki.simonstrator.api.component.sis.SiSComponent;
import de.tudarmstadt.maki.simonstrator.api.component.sis.SiSInformationConsumer;
import de.tudarmstadt.maki.simonstrator.api.component.sis.SiSInformationProvider;
import de.tudarmstadt.maki.simonstrator.api.component.sis.SiSRequest;
import de.tudarmstadt.maki.simonstrator.api.component.sis.SiSResultCallback;
import de.tudarmstadt.maki.simonstrator.api.component.sis.exception.InformationNotAvailableException;
import de.tudarmstadt.maki.simonstrator.api.component.sis.type.SiSType;
import de.tudarmstadt.maki.simonstrator.api.component.sis.type.SiSTypes;
import de.tudarmstadt.maki.simonstrator.api.component.transport.TransportComponent;

public class MinimalSiSHost implements Host, SiSComponent {

	private INodeID nodeId = null;
	private Random rand = new Random();

	public MinimalSiSHost(INodeID nodeId) {
		this.nodeId = nodeId;
	}

	@SuppressWarnings("unchecked")
	@Override
	public <T extends HostComponent> T getComponent(Class<T> componentClass) throws ComponentNotAvailableException {
		if (componentClass.equals(SiSComponent.class)) {
			return (T) this;
		}
		return null;
	}

	@Override
	public <T extends HostComponent> void registerComponent(T component) {
		// TODO Auto-generated method stub

	}

	@Override
	public <T extends HostComponent> boolean removeComponent(T component) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public <T extends HostComponent> List<T> getComponents(Class<T> componentClass)
			throws ComponentNotAvailableException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public TransportComponent getTransportComponent() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public NetworkComponent getNetworkComponent() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public INodeID getId() {
		return this.nodeId;
	}

	@Override
	public long getHostId() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public void initialize() {
		// TODO Auto-generated method stub

	}

	@Override
	public void shutdown() {
		// TODO Auto-generated method stub

	}

	@Override
	public Host getHost() {
		return this;
	}

	@Override
	public SiSInformationProvider provide() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public SiSInformationConsumer get() {
		// TODO Auto-generated method stub
		return new SiSInformationConsumer() {

			@Override
			public void revoke(SiSConsumerHandle handle) {
				// TODO Auto-generated method stub

			}

			@Override
			public <T> T remoteObservationOf(INodeID observer, INodeID observedNode, SiSType<T> type,
					SiSRequest request) throws InformationNotAvailableException {
				// TODO Auto-generated method stub
				return null;
			}

			@Override
			public <T> SiSConsumerHandle rawObservations(SiSType<T> type, SiSRequest request,
					SiSResultCallback<Map<INodeID, T>> callback) {
				// TODO Auto-generated method stub
				return null;
			}

			@SuppressWarnings("unchecked")
			@Override
			public <T> T localState(SiSType<T> type, SiSRequest request) throws InformationNotAvailableException {

				if (type.equals(SiSTypes.LATENCY_CELL)) {
					// LATENCY_CELL returns always 0
					return (T) new Double(0);
				} else if (type.equals(SiSTypes.ENERGY_BATTERY_CAPACITY)) {
					// Battery Capacity returns a value between 10k and 20k
					return (T) new Double((rand.nextDouble() + 1.0) * 10000.0);
				}

				return null;
			}

			@Override
			public <T> T localObservationOf(INodeID observedNode, SiSType<T> type, SiSRequest request)
					throws InformationNotAvailableException {
				// TODO Auto-generated method stub
				return null;
			}

			@Override
			public <T> Map<INodeID, T> allLocalObservations(SiSType<T> type, SiSRequest request) {
				// TODO Auto-generated method stub
				return null;
			}

			@Override
			public <T> SiSConsumerHandle aggregatedObservation(AggregationFunction aggFunction, SiSType<T> type,
					SiSRequest request, SiSResultCallback<T> callback) {
				// TODO Auto-generated method stub
				return null;
			}
		};
	}
}
