package de.tudarmstadt.maki.simonstrator.api.component.vehicular.api;

import java.util.List;

import de.tudarmstadt.maki.simonstrator.api.component.vehicular.api.information.Position;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkRoute;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.exception.NoAdditionalRouteAvailableException;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.exception.NoExitAvailableException;

public interface VehicleController {
	void setObservedArea(double pStartX, double pStartY, double pEndX, double pEndY);

	Position getVehiclePosition(String pVehicleID);
	Position getVehiclePosition(double pStep, String pVehicleID);

	boolean nextStep();

	List<String> getAllVehicles();
	List<String> getAllVehicles(double pStep);

	RoadNetworkRoute getCurrentRoute(String pVehicleID);

	double getMaximumAvailablePrediction();

	void rerouteVehicle(String pVehicle, RoadNetworkRoute pRoute);
	RoadNetworkRoute findNewRoute(String pVehicle)
			throws NoAdditionalRouteAvailableException;
	RoadNetworkRoute findNewRoute(String pVehicle,
			List<RoadNetworkEdge> pEdgesToAvoid, boolean pKeepDestination)
					throws NoAdditionalRouteAvailableException,
					NoExitAvailableException;

	double getStep();
	double getStart();

	void init();

	double getVehicleSpeed(String pVehicleID);
	void stopVehicle(String pVehicle);
}
